***
***
# <a name="faq"> </a>FAQ

## GRIDSTACK IN A NUTSHELL
Gridstack is a layout factory/ creator. Similar to how you create layouts by
code, only with Gridstack, you create layouts with a drag and drop.

It is capable of building the most complex layouts you can imagine visually
right in the browser. Call it designing layouts on the browser.

Even if you love coding everything by hand, you will soon find Gridstack handy
for various reasons:

* configurability,
* exportability,
* easy integration with various layout builders,
* easy modification to suit your heart contents,
* etc.

**Gridstack layouts come in two flavors:**

1. **The css-driven layouts**

   Integrates with Bootstrap or Foundation CSS frameworks.
   Hence Gridstack is useless till you install one of the layout builders which
   can make use of Gridstack layouts:

   Display Suite, Panels, Layout Builder, Widget, etc.

   No Gridstack CSS and JS are loaded. You must have a theme or module which
   load the grid CSS framework for you.

2. **The js-driven layouts**

   Gridstack has formatters and Views style plugins to build magazine layouts.

Both layout flavors are usable for Display Suite, Panels, Layout Builder, etc.
Region or wrapper attributes, including their HTML tags are configurable via
Layout builder for both flavors.

## REGISTERING SKINS
1. Copy `\Drupal\gridstack\Plugin\gridstack\GridStackSkin` into your module
  `/src/Plugin/gridstack directory`.
2. Adjust everything accordingly: rename the file, change GridStackSkin ID and
  label, change class name and its namespace, define skin name, and its CSS and
  JS assets.

The GridStackSkin object has 1 supported method: `::setSkins()`.

The declared skins will be available for custom coded, or UI selections.
Be sure to clear cache since skins are permanently cached!

## CURRENT DEVELOPMENT STATUS
A full release should be reasonable after proper feedback from the community,
some code cleanup, and optimization where needed. Patches are very much welcome.

Alpha, Beta, DEV releases are for developers only. Beware of possible breakage.

However if it is broken, unless an update is provided, running `drush cr` during
DEV releases should fix most issues as we add new services, or change things.
If you don't drush, before any module update, always open:

[Performance](/admin/config/development/performance)

And so you are ready to hit **Clear all caches** if any issue.
Only at worst case, know how to run
https://www.drupal.org/project/registry_rebuild safely.
